var invoke_code = 0;
var native_api_callback_functions = {};
function native_invoke_code()
{
    return invoke_code++;
}
function native_invoke(api, args, callback)
{
    if (!args)
    {
        args = {};
    }
    var code = -1;//not return
    if (typeof window.JsBridge == 'undefined')
    {
        if (callback)
        {
            callback({"success": false, "message": "can not invoke native api"});
        }
    }
    else
    {
        if (callback)
        {
            code = native_invoke_code();
            native_api_callback_functions[code] = callback;
        }
        JsBridge.invoke(api, JSON.stringify(args), code);
    }
}

function native_callback(code, result)
{
    var func = native_api_callback_functions[code];
    if (func)
    {
        native_api_callback_functions[code] = null;
        func(result);
    }
}

function go_back(index)
{
    if (typeof window.JsBridge != 'undefined')
    {
        native_invoke("go_back");
    }
    else
    {
        window.history.go(index);
    }
}
