var invoke_code = 0;
var native_api_callback_functions = {};
var unInvokedRequests = {};

var messageBoxFunction="YLMessageBox";
var confirmFunction="YLConfirm";
var loadingFunction="YLLoading";
var closeFunction="YLClose";
var imageSrcFunction="YLImageSrc";
var loadingFinishFunction="loadingFinish";
var kAction = "YLAction";

var kViewWillAppear = "YLViewWillAppear";
var kPushNavigation = "YLPushNavigation";
var kPresentNavigation = "YLPresentNavigation";
var kDismissNavigation = "YLDismissNavigation";
var kPopNavigation = "YLPopNavigation";
 /*navigation data {"isweb":0,"url":"http://www.youjiagou.com","size":"{3.0,2.5}","action":kPushNavigation}*/

var EventClickAddSubaccount = "42";
var EventClickConfigRule = "43";

function setupWebViewJavascriptBridge(callback) {
	if (window.WebViewJavascriptBridge) { return callback(WebViewJavascriptBridge); }
	if (window.WVJBCallbacks) { return window.WVJBCallbacks.push(callback); }
	window.WVJBCallbacks = [callback];
	var WVJBIframe = document.createElement('iframe');
	WVJBIframe.style.display = 'none';
	WVJBIframe.src = 'wvjbscheme://__BRIDGE_LOADED__';
	document.documentElement.appendChild(WVJBIframe);
	setTimeout(function() { document.documentElement.removeChild(WVJBIframe) }, 0)
}

function isNull(value)
{
	return value==undefined || value==''|| value==null;
}

function uuid() {
	  var s = [];
	  var hexDigits = "0123456789abcdef";
	  for (var i = 0; i < 36; i++) {
		  s[i] = hexDigits.substr(Math.floor(Math.random() * 0x10), 1);
	  }
	  s[14] = "4";  // bits 12-15 of the time_hi_and_version field to 0010
	  s[19] = hexDigits.substr((s[19] & 0x3) | 0x8, 1);  // bits 6-7 of the clock_seq_hi_and_reserved to 01
	  s[8] = s[13] = s[18] = s[23] = "";
	  
	  var uuid = s.join("");
	  return uuid;
}

function native_invoke_code()
{
    return invoke_code++;
}

function native_invoke(api, args, callback)
{
    //alert("api:")
    if (!args)
    {
        args = {};
    }
    var code = -1;//not return
    if (typeof window.WebViewJavascriptBridge == 'undefined')
    {
        var request = {"api": api, "args": args, "callback": callback};
        unInvokedRequests[native_invoke_code()] = request;
    }
    else
    {
        if (callback)
        {
            code = native_invoke_code();
            native_api_callback_functions[code] = callback;
        }
        WebViewJavascriptBridge.callHandler('invoke', {"code": code, "api": api, "params": args}, function (response)
        {
           native_callback(response.code, response.result);
        });
    }
}

function native_callback(code, result)
{
    var func = native_api_callback_functions[code];
    if (func)
    {
        native_api_callback_functions[code] = null;
        func(result);
    }
}

if (window.WebViewJavascriptBridge)
{
    WebViewJavascriptBridge.init(function (message, responseCallback)
    {
    });
}
else
{
	setupWebViewJavascriptBridge(function(bridge){});
    document.addEventListener('WebViewJavascriptBridgeReady', function ()
    {
//        window.alert = function (message)
//        {
//            native_invoke("alert", {"message": message});
//        };
        WebViewJavascriptBridge.init(function (message, responseCallback)
        {
        });
        for (var index in unInvokedRequests)
        {
            native_invoke(unInvokedRequests[index].api, unInvokedRequests[index].args, unInvokedRequests[index].callback);
        }
    }, false);
}
//if (window.WebViewJavascriptBridge)
//{
//    window.alert = function (message)
//    {
//        native_invoke("alert", {"message": message});
//    };
//}

function go_back(index)
{
    if (window.WebViewJavascriptBridge)
    {
        native_invoke("go_back");
    }
    else
    {
        window.history.go(index);
    }
}

/**
 * 确认事件
 * example：ylconfirm({"name":"YJGStoreOrderListVC"},function(data){});
 * @param args 参数值，json对象
 * @param callback 回调函数
 */
function ylconfirm(args,callback)
{		  
	  setupWebViewJavascriptBridge(function(bridge) {
	  bridge.callHandler(confirmFunction,args,function responseCallback(data) {
		  console.log("JS received response:", data)
		  if(callback)
		  {
			  callback(data);
		  }
	  	  })
	  })
}

function ylloading(loading)
{	  
	setupWebViewJavascriptBridge(function(bridge) {
	bridge.callHandler(loadingFunction,loading,function responseCallback(data) {
		console.log("JS received response:", data)
		})
	})
}

function yltrackevent(trackevent,trackvalue)
{  
	setupWebViewJavascriptBridge(function(bridge) {
	
	if(isNull(trackvalue))
	{
		trackvalue = "";
	}
	if(isNull(trackevent))
	{
		trackevent = "";
	}	
	var trackBackData = {"YLTrackEvent":trackevent,"YLTrackValue":trackvalue};	
	bridge.callHandler("YLTrack",trackBackData,function responseCallback(data) {
		console.log("JS received response:", data)
		})
	})	
}

function ylClose(result)
{
	if(window.WebViewJavascriptBridge)
	{
		if(isNull(result))
		{
			result = '';
		}
		setupWebViewJavascriptBridge(function(bridge) {
        bridge.callHandler(closeFunction,result,function responseCallback(data) {
            console.log("JS received response:", data)
        	})
        })
	}	
}

function ylimagesrc(result,callback)
{
	if(window.WebViewJavascriptBridge)
	{
	  setupWebViewJavascriptBridge(function(bridge) {
		  bridge.callHandler(imageSrcFunction,result,function responseCallback(data) {
			  console.log("JS received response:", data)
			  if(callback){
				  callback(data);
			  }
		  })
	  })
	}
}

function ylaction(result,callback)
{
    setupWebViewJavascriptBridge(function(bridge){
        bridge.callHandler(kAction,result,function(data){
            console.log("JS received response:", data)
            if (callback) {
                callback(data);
            }
        });
    });
}