var sUserAgent = navigator.userAgent.toLowerCase();
var isIphone = sUserAgent.match(/iphone/i) == "iphone";
var isIpad = sUserAgent.match(/ipad/i) == "ipad";


if (isIphone || isIpad)
{
    document.write("<script src='../js/ios.api.js'><\/script>");
}
else
{
    document.write("<script src='../js/android.api.js'><\/script>");
}

function query_string(key)
{
    var svalue = location.search.match(new RegExp("[\?\&]" + key + "=([^\&]*)(\&?)", "i"));
    return svalue ? svalue[1] : svalue;
}

function reg_view_appear(callback)
{
    native_invoke("reg_view_appear", {}, function (result)
    {
        if (result.success)
        {
            reg_view_appear(callback);
            callback();
        }
    });
}


//var base_url = "http://192.168.1.43/";
// var submit_url = "http://192.168.1.114:8281/DSORM/openService.do?"//测试环境app接口地址
// var image_url = "http://192.168.1.183:8988/";//测试环境图片地址

 var base_url = window.location.origin+"/";//正式环境接口地址
 var image_url = window.location.protocol+"//image.youjiagou.com/";//正式环境图片地址
 var submit_url = window.location.protocol+"//dsorm.youjiagou.com/openService.do"//正式环境app接口地址

function ajax_request(url, method, param) //访问老接口
{
    native_invoke("gettoken", null, function (result)
    {
        var params = '{"method":"' + method + '","param":' + param + "," + '"url":"' + url + '","version":"v2"}'
        var urls = base_url + "service/app.do?param=" + params
        $.ajax
            (
            {
                type: "GET",
                dataType: "json",
                url: encodeURI(urls),
                headers: {
                    "Access-Control-Allow-Origin": "*",
                    "authorization": result,
                    "Access-Control-Allow-Headers": "X-Requested-With"
                },
                beforeSend: function (request)
                {
                    request.setRequestHeader("authorization", result);
                    request.setRequestHeader("Access-Control-Allow-Origin", "*");
                },
                success: function (result)
                {
                    //alert(JSON.stringify(result))
                    alert('success');
                },
                error: function (result)
                {
                    alert('fail')
                }
            })
    });
}

function ajax_requestrule(params, callback, needtoken)
{
   
    if (needtoken)
    {
        getSec(function ()
        {
            var ua = doSign(getCookieValue("gs"), decodeURIComponent(params));
            var urls = base_url + "appinterface"
            $.ajax
                ({
                    data: params,
                    type: 'POST',
                    dataType: 'json',
                    url: encodeURI(urls),
                    headers: {
                        "ua": ua,
                    },
                    beforeSend: function (request)
                    {
                        request.setRequestHeader("ua", ua);
                    },
                    success: function (result)
                    {
                        //alert(JSON.stringify(result))
                        var json = JSON.parse(JSON.stringify(result))
                        var code = json.code;
                        if (code == "0")
                        {
							if(callback)
							{
                            	callback(json.rows)
							}
                        }
                        else
                        {
							if(callback)
							{							
                            	callback(null);
							}
                            //alert('没有数据');
                            alert(json.description);
                        }
                    },
                    error: function (result)
                    {
						if(callback)
						{							
							callback(null);
						}
						alert('请求失败');
                        //alert('fail:' + result)
                    }
                })
        })
    }
    else
    {
        var urls = base_url + "appinterface?" + params;
        $.ajax
            (
            {
                type: "GET",
                dataType: "json",
                url: encodeURI(urls),
                headers: {
                    "Access-Control-Allow-Headers": "X-Requested-With"
                },
                success: function (result)
                {
                    //alert(JSON.stringify(result))
                    var json = JSON.parse(JSON.stringify(result))
                    var code = json.code;
                    if (code == "0")
                    {
                        callback(json.rows)
                    }
                    else
                    {
                        //callback(json.rows)
                        //alert('没有数据');
                        alert(json.description);
                    }
                },
                error: function (result)
                {
                    //alert(JSON.stringify(result))
                }
            })
    }

}


function getSec(callback)
{
    var param = {};
    param["action"] = "getAction";
    param["method"] = "getSec";
    var paramStr = JSON.stringify(param);
    $.ajax
        ({
            type: "GET",
            dataType: "json",
            url: encodeURI(base_url + "appinterface.do?" + paramStr),
            headers: {
                "Access-Control-Allow-Headers": "X-Requested-With"
            },
            success: function (result)
            {
                callback(result);
            },
            error: function (result)
            {
                callback(result);
            }
        })
}

/**
 * rsa签名
 * @param content 签名内容
 */
function doSign(pem, content)
{
    if (typeof KEYUTIL == 'undefined')
{
        return '';
    }
    var key = KEYUTIL.getKey(pem);
    var sigValueHex = key.signString(content, "sha1");
    return sigValueHex;
}


/**获取cookie的值，根据cookie的键获取值**/
function getCookieValue(name)
{
    var trim = function (str)
{
        return str.replace(/^(\s*)|(\s*)$/g, "");
    };
    var cookies = document.cookie.split(";");
    for (var i = 0; i < cookies.length; i++)
{
        var cookie = cookies[i];
        var cookieStr = cookie.split("=");
        if (cookieStr && trim(cookieStr[0]) == decodeURI(name))
{
            try
{
                return decodeURIComponent(cookieStr[1]);
            }
            catch (e)
{
                return unescape(cookieStr[1]);
            }
        }
    }
    //搜索失败，返回空字符串
    return "";
}


// function ajax_requestrule(params, callback, method)
// {
//     ajax_post2(base_url + "appinterface?",params,
//         function(result)
//         {
//             //alert(JSON.stringify(result))
//             var json = JSON.parse(result)
//             var code = json.code;
//             if (code == "0")
//             {
//                 callback(json.rows)
//             }
//             else
//             {
//                 //callback(json.rows)
//                 //alert('没有数据');
//             }
//         },method);
// }

function setupWebViewJavascriptBridge(callback)
{
    if (window.WebViewJavascriptBridge) { return callback(WebViewJavascriptBridge); }
    if (window.WVJBCallbacks) { return window.WVJBCallbacks.push(callback); }
    window.WVJBCallbacks = [callback];
    var WVJBIframe = document.createElement('iframe');
    WVJBIframe.style.display = 'none';
    WVJBIframe.src = 'wvjbscheme://__BRIDGE_LOADED__';
    document.documentElement.appendChild(WVJBIframe);
    setTimeout(function () { document.documentElement.removeChild(WVJBIframe) }, 0)
}